Application: gvSIG desktop - gvSIG bugs #4370
Excepcion al ordenar la tabla de atributos con la capa en edicion
09/16/2016 03:45 PM - Francisco Puga

Status: Outdated % Done: 0%
Priority: Normal Spent time: 0.00 hour
Assignee:

Category: Document table

Target version: 2.4.0-2822 (rev. org.gvsig.deskiop-2.0.188)

Severity: Minor Add-on version:

gvSIG version: 2.3.0 Add-on build:

gvSIG build: Add-on resolve version:
Operative System: Add-on resolve build:
Keywords: Proyecto:

Has patch: Hito:

Add-on name: Unknown

Description

Si se ordena la tabla de atributos después de haber afiadido una nueva feature (geométricamente) y se ordena la tabla se produce
una extension por consola.

Por lo que he podido ver, el problema de fondo esta en que cuando al FeaturePagingHelper se le pasa una query donde se le
especifica un FeatureQueryOrder, ninguna de las features devueltas tiene el isNewFeature a true. Cuando se intenta usar el
equals/hashCode sobre una feature nueva pero que no tiene isNew = true, se produce un NullPointerException.

History

#1 - 09/19/2016 10:59 AM - Alvaro Anguix

- Category set to Document table

#2 - 11/07/2016 08:19 PM - Francisco Puga

- Status changed from New to Awaiting response

El bug no afecta solamente a la tabla. Es un problema del iterador. Afecta a todo el cédigo que pida los datos ordenados (FastOrderedlterator) cuando
haya nuevas features creadas (teniendo la capa en edicién). Creo que es un problema grave porque muchas aplicaciones pueden depender de

recorrer los datos en un determinado orden, incluso cuando se hayan insertado nuevas features.

En DefaultFeatureSet.fastlterator, cuando estamos en el caso de ORDERD_EDITED (no he comprado si sucede también con
ORDERED_EDITED_FILTER) se crea un FastOrderedlterator que tiene dentro un FastEditedlterator.

Cuando se va a devolver una Feature, llamando al createFeature, el FastEditedlterator setea correctamente el isNew del FeatureProvider. Pero hay
un momento del flujo en que se acaba llamando a FastOrderedlterator.createFeature(FeatureProvider fData). En este método no se respecta el fData

original si no que se hace " fData.setNew(false) ™" cargandose el valor original que viene del FastEditedlterator y que si que es correcto. Eliminando
esa llamada todo parece funcionar (adjunto parche).

He tratado de ver si eso se habia introducido hace poco por algin motivo pero la clase parece no haberse tocado en varios afios.

#3 - 11/07/2016 08:20 PM - Francisco Puga

Al subir el fichero del parche me da un "Server internal error" pero vamos el cambio es trivial:
https://redmine.gvsig.net/redmine/projects/gvsig-desktop/repository/changes/trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/featureset/FastOrderedIterator.java

Index: src/main/java/org/gvsig/fmap/dal/feature/impl/featureset/FastOrderedlterator.java

--- src/main/java/org/gvsig/fmap/dal/feature/impl/featureset/FastOrderedlterator.java (revision 43073)
+++ src/main/java/org/gvsig/fmap/dal/feature/impl/featureset/FastOrderedlterator.java  (working copy)
@@ -88,7 +88,6 @@

}

protected DefaultFeature createFeature(FeatureProvider fData) {
- fData.setNew(false);

this.myFeature.setData(fData);

return this.myFeature;

#4 - 06/06/2017 04:05 PM - Joaquin del Cerro Murciano
- Target version set to 2.4.0-2821 (rev. org.gvsig.desktop-2.0.187)

#5 - 06/10/2017 06:51 PM - Joaquin del Cerro Murciano
- Target version changed from 2.4.0-2821 (rev. org.gvsig.desktop-2.0.187) to 2.4.0-2822 (rev. org.gvsig.desktop-2.0.188)

#6 - 06/13/2017 05:04 PM - Francisco Diaz Carsi

- Status changed from Awaiting response to Outdated

Lo paso a "outdated" porque en el build 2021 esto ya no ocurre.
